c----------------------------------------------------------------------
c	The program recalculates the crust models obtained by 3smak program
c	(form_eos) to homogeneous layered structure and adds the
c	homogeneous layered PREM model (file 'prem4smac') for depth range
c	from Moho boundary up to 2021 km. The values of half-space 
c	characteristics are taken equal to the average values in original
c	PREM model in the depth range from 2021 km to 2071 km.
c----------------------------------------------------------------------
	real*4 rad(1000),vp(1000),vs(1000),rho(1000),d_hom(1000),
     *vp_hom(1000),vs_hom(1000),rho_hom(1000)
	character*80 filein,fileout
	integer n_name,n1,nr,nrad,nl,nadd
	open(11,file='list_mod')
		do i=1,1000
		fileout=char(0)
		read(11,10,end=1)filein
10		format(a)
		n_name=lnblnk(filein)
		n1=n_name-3
		fileout(1:n1)=filein(1:n1)
		fileout(n1+1:n_name)='mod'
				open(12,file=filein)
				read(12,*) nrad
				read(12,*)
				read(12,*)
				read(12,*)
				do j=1,nrad
				read(12,*)nr,rad(nrad-j+1),rho(nrad-j+1),
     *						vp(nrad-j+1),vs(nrad-j+1)
				end do
				close(12)
					nl=0
					dep=0.
					do j=2,nrad
					d=rad(j-1)/1000.-rad(j)/1000.
						if(d.gt.1e-6) then
						d_hom(nl+1)=d
						vp_hom(nl+1)=(vp(j-1)+vp(j))/2.
						vs_hom(nl+1)=(vs(j-1)+vs(j))/2.
						rho_hom(nl+1)=(rho(j-1)+rho(j))/2.
					if(vp_hom(nl+1).lt.7.5) then
						dep=dep+d
						nl=nl+1
					else 
					go to 777
					end if
						end if
					end do
777			continue
c-----------------------------------------------------------------------
c	Adding of PREM structure beneath the 3SMAC crust model. 
c-----------------------------------------------------------------------
			open(12,file='prm4smac',status='old',err=100)
			nadd=0
			dep1=0.
			iPREM=0
c-----------------------------------------------------------------------
c	Array rad(j) is used below for layer thiknesses
c-----------------------------------------------------------------------
				do j=1,1000
				read(12,*,end=2)rad(j),vp(j),vs(j),rho(j)
			dep1=dep1+rad(j)
		if(dep1.gt.dep) then
			if(iPREM.eq.0) then
				if(dep1.gt.24.4) then 
				n1PREM=j
				rad(n1PREM)=dep1-dep
				iPREM=1
				end if
			end if
						if(iPREM.eq.1)nadd=nadd+1
		end if
				end do
2				continue
			close(12)
				open(12,file=fileout)
				write(12,*)nl+nadd
					do j=1,nl
				write(12,*)d_hom(j),vp_hom(j),vs_hom(j),rho_hom(j)
					end do
					do j=n1PREM,n1PREM+nadd-2
				write(12,*)rad(j),vp(j),vs(j),rho(j)
					end do
			write(12,*)'           ',
     *				vp(n1PREM+nadd-1),vs(n1PREM+nadd-1),rho(n1PREM+nadd-1)
				close(12)
		end do
1		continue
	close (11)
				go to 101
100											continue
		print*,'There is no file prem4smac in the working directory!'
101											continue
				STOP
				END
c ****************************************
      integer function lnblnk(chaine)
c ****************************************
c  lnblnk est la longueur de la chaine chaine 
c  lnblnk=0 s'il n'y a que des blancs
c
      character*(*) chaine
      character*1 car
c                            
      lnblnk=len(chaine)
 10   car=chaine(lnblnk:lnblnk)
      if (car.ne.' '.and.car.ne.char(0)) return
      lnblnk=lnblnk-1
      if (lnblnk.gt.0) goto 10
      lnblnk=0
      return
      end
