#ifndef _SEI_SEI_H__
#define _SEI_SEI_H__
#define TRUE   1 
#define FALSE  0 
typedef int BOOL;
#define  _MAX_LENGTH_NAME  200
#define N_SEI            ps->n 

typedef struct orig 
{

	int doy, last_doy, orid, evid;
	char etype[32];
	char dtype[32];
	char algorithm[32];
        char author[64];
        double epoph;
	double lddate;

    int year,month,day,hour,minute;
    float second;
    float latitude;                     
    float longitude;                  
    float dep;                       
    float mb;                     
    float ms;                      
    float ml;  
                   
} ORIG;
    
typedef struct file_sei 
     { 
/*  ======================= common  START =======================*/ 
                           /*    fortran record 1 >: */ 
      short rec_cod1; 
      char rectyp[4];      /* identifier   */ 
      long  nh;             /* number of records before array */ 
      
/* ======================= common HEADER =======================*/ 
                           /* fortran record 2 >: */ 
      short rec_cod2; 
      long lh;              /* lh=168 - length of common header */ 
 
                           /* fortran record 3 >: (character 168)*/ 
      short rec_cod3; 
      char header[79];     /*  comment             */ 
      char comp[2];           /*  component (z,n,e,r,t)   */ 
      char instr[9];       /*  type of seismometer */ 
      char st_name[10];        /*  station name        */ 
 
/* ----------------------- Origin time >: -----------------------*/ 
                               
      long  year; 
      long  month; 
      long  day; 
      long  hour; 
      long  minute; 
      float sec; 
 
/* ----------------------- hypocenter  >: -----------------------*/ 
 
      float elat; 
      short spec_code; 
      float elong; 
      float depth;   
 
/* ----------------------- station     >: -----------------------*/ 
 
      float slat; 
      float slong; 
      float elevation; 
 
/* ---------- instrument's orientation (degrees) >: -------------*/ 
 
      float polan;         /*  angle with vertical   */    
      float az;            /*  azimuth               */ 
      float dist;          /*  distance from Station */ 
                           /*  to epicenter          */ 
      float aztos;         /*  azimuth to Station    */ 
      float azfrs;         /*  azimuth from Station  */ 
                                                      
/* ======================= TIME - HEADER ============================*/ 
 
                           /* fortran record 4 >:  */ 
       short rec_cod4; 
       long  lh_time;         /* lh_time=16 - length of time-header */ 
 
                           /* fortran record 5 >:  */ 
       short rec_cod5; 
       long  nsampl;        /* number of Points     */ 
       float  t0;            /* Start time of record */ 
       float  dt;            /* Time interval        */ 
       float  amp;           /* signal amplitude     */ 
                                    
/* ===================RESPONSE - HEADER =============================*/ 
 
                           /* fortran record 6 >:  */ 
 /* record 6 information about response (1 record) */ 
 
       short rec_cod6; 
        long  icot;             /* type of instrument correction :   */ 
                                /* icot   = 0  -  uncertain          */ 
            /* ABS(icot)  = 1  -  no correction in the past          */ 
            /* ABS(icot)  = 2  -  wrong information about correction */ 
            /* ABS(icot)  > 2  -  type of correction                 */ 
            /*    "icot" always is WRITTEN into file "namo"          */ 
            /*     but information itself ONLY if  incor > 0         */ 
        char rsptype[7];
        long   nzer;            /* number of zeros                   */ 
        long   npol;            /* number of poles                   */ 
        float  amp1;            /* a leading factor of the           */ 
                                /*          instrumental response    */  
        float  amp2;            /* sensitivity of instrument, bit/m  */ 
        float  zer[20][2];      /* array of zeros (re,im)            */ 
        float  pol[50][2];      /* array of poles (re,im)            */ 
/*  ======================= End definition ======================*/ 
   char name[30];

/*   To SPDISC              */
    char      sta[7];
    char      n_sta[12];
    char      chan[9];
    char      inichan[9];
    char      LRchan[9];
    long      chanid; 
    double    time;
    double    endtime;
    long      jdate;
    long      nsamp ;
    float     calib ;
    float     calper ;
    float     samprate ;
    char      segtype;
/*   ---------------------   */
    char      dir[_MAX_LENGTH_NAME];
    char      dfile[_MAX_LENGTH_NAME]; 
    long      wfid;
    char      instype[7];
    char      datatype[3];
    char      clip[2];
    long      foff;
    long      commid ; 
    double     lddate;
    char  dir_instr[_MAX_LENGTH_NAME];
    char  dfile_instr[_MAX_LENGTH_NAME];

        float *s;
      } SEI;
 
  

typedef struct sac
{
    float           delta;	       /* RF time increment, sec     */
    float           depmin;	       /* minimum amplitude       */
    float           depmax;	       /* maximum amplitude       */
    float           scale;	       /* amplitude scale factor  */
    float           odelta;	       /* observed time inc       */
    float           b;		       /* RD initial value, ampl.    */
    float           e;		       /* RD final value, amplitude  */
    float           o;		       /* event start, sec > 0    */
    float           a;		       /* 1st arrival time        */
    float           internal1;	       /* internal use            */
    float           t[10];	       /* user-defined time pick  */
    float           f;		       /* event end, sec > 0      */
    float           resp[10];	       /* instrument respnse parm */
    float           stla;	       /* T station latititude      */
    float           stlo;	       /* T station longitude       */
    float           stel;	       /* T station elevation, m    */
    float           stdp;	       /* T station depth, m        */
    float           evla;	       /* event latitude          */
    float           evlo;	       /* event longitude         */
    float           evel;	       /* event elevation         */
    float           evdp;	       /* event depth             */
    float           unused1;	       /* reserved for future use */
    float           user[10];	       /* available to user       */
    float           dist;	       /* stn-event distance, km  */
    float           az;		       /* event-stn azimuth       */
    float           baz;	       /* stn-event azimuth       */
    float           gcarc;	       /* stn-event dist, degrees */
    float           internal2;	       /* internal use            */
    float           internal3;	       /* internal use            */
    float           depmen;	       /* mean value, amplitude   */
    float           cmpaz;	       /* T component azimuth       */
    float           cmpinc;	       /* T component inclination   */
    float           unused2;	       /* reserved for future use */
    float           unused3;	       /* reserved for future use */
    float           unused4;	       /* reserved for future use */
    float           unused5;	       /* reserved for future use */
    float           unused6;	       /* reserved for future use */
    float           unused7;	       /* reserved for future use */
    float           unused8;	       /* reserved for future use */
    float           unused9;	       /* reserved for future use */
    float           unused10;	       /* reserved for future use */
    float           unused11;	       /* reserved for future use */
    float           unused12;	       /* reserved for future use */
    int             nzyear;	       /* F zero time of file, yr   */
    int             nzjday;	       /* F zero time of file, day  */
    int             nzhour;	       /* F zero time of file, hr   */
    int             nzmin;	       /* F zero time of file, min  */
    int             nzsec;	       /* F zero time of file, sec  */
    int             nzmsec;	       /* F zero time of file, msec */
    int             internal4;	       /* internal use            */
    int             internal5;	       /* internal use            */
    int             internal6;	       /* internal use            */
    int             npts;	       /* RF number of samples       */
    int             internal7;	       /* internal use            */
    int             internal8;	       /* internal use            */
    int             unused13;	       /* reserved for future use */
    int             unused14;	       /* reserved for future use */
    int             unused15;	       /* reserved for future use */
    int             iftype;	       /* RA type of file            */
    int             idep;	       /* type of amplitude       */
    int             iztype;	       /* zero time equivalence   */
    int             unused16;	       /* reserved for future use */
    int             iinst;	       /* recording instrument    */
    int             istreg;	       /* stn geographic region   */
    int             ievreg;	       /* event geographic region */
    int             ievtyp;	       /* event type              */
    int             iqual;	       /* quality of data         */
    int             isynth;	       /* synthetic data flag     */
    int             unused17;	       /* reserved for future use */
    int             unused18;	       /* reserved for future use */
    int             unused19;	       /* reserved for future use */
    int             unused20;	       /* reserved for future use */
    int             unused21;	       /* reserved for future use */
    int             unused22;	       /* reserved for future use */
    int             unused23;	       /* reserved for future use */
    int             unused24;	       /* reserved for future use */
    int             unused25;	       /* reserved for future use */
    int             unused26;	       /* reserved for future use */
    int             leven;	       /* RA data-evenly-spaced flag */
    int             lpspol;	       /* station polarity flag   */
    int             lovrok;	       /* overwrite permission    */
    int             lcalda;	       /* calc distance, azimuth  */
    int             unused27;	       /* reserved for future use */
    char            kstnm[8];	       /* F station name            */
    char            kevnm[16];	       /* event name              */
    char            khole[8];	       /* man-made event name     */
    char            ko[8];	       /* event origin time id    */
    char            ka[8];	       /* 1st arrival time ident  */
    char            kt[10][8];	       /* time pick identifiers   */
    char            kf[8];	       /* end of event ident      */
    char            kuser[3][8];       /* available to user       */
    char            kcmpnm[8];	       /* F component name          */
    char            knetwk[8];	       /* network name            */
    char            kdatrd[8];	       /* date data read          */
    char            kinst[8];	       /* instrument name         */
}               sac_t;
typedef struct set_sei 
     { 
      int n;
      long max_nsampl;
      char *dir_locate;
      SEI **sei;  
       int n_or;
       ORIG **ori;
      } SET_SEI; 


#endif
