//	DrawCnvCmd.h:	Header for myCmdWindow class
//=======================================================================

#ifndef myCMDW_H
#define myCMDW_H

#include <v/vcmdwin.h>	// So we can use vCmdWindow
#include <v/vmenu.h>	// For the menu pane
#include <v/vutil.h>	// For V Utilities
#include <v/vcmdpane.h> // command pane
#include <v/vstatusp.h>	// For the status pane
#include <v/vtimer.h>	// Timer

#ifdef vDEBUG
#include <v/vdebug.h>
#endif

#include "DrawCanv.h"
#include "seis.h"


    class myCmdWindow;

    class myTimer : public vTimer
      {
      public:		//---------------------------------------- public
	myTimer(myCmdWindow* cw) { cmdw = cw; }
	~myTimer() {}
	virtual void TimerTick();
      private:		//--------------------------------------- private
	myCmdWindow* cmdw;
      };

    class myCmdWindow : public vCmdWindow
      {
	friend int AppMain(int, char**);	// allow AppMain access

      public:		//---------------------------------------- public
	myCmdWindow(char*, int, int,SET_SEI *,char**,int ,int,int);
//myCmdWindow(char*, int, int,char *);
	virtual ~myCmdWindow();
	virtual void WindowCommand(ItemVal id, ItemVal val, CmdType cType);
	virtual void KeyIn(vKey keysym, unsigned int shift);
      protected:	//--------------------------------------- protected

      private:		//--------------------------------------- private

	// Standard elements
	vMenuPane* myMenu;		// For the menu bar
	CDrawIntervalsPane   * CDrawIntervalsCanvasPane;		// For the canvas
	vCommandPane* CDrawCmdPane2;	// for the command pane
	vStatusPane* myStatus;		// For the status bar
	myTimer* _timer;	// Timer for Date/Time

	// Dialogs associated with CmdWindow

	//myDialog* myDlg;

      };
#endif
