//	FmtEcmdw.h:	Header for FmtOriginCmdWindow class
//=======================================================================

#ifndef FmtOriginCMDW_H
#define FmtOriginCMDW_H
const int _MAX_FILE_NAME  = 200;

#include <v/vcmdwin.h>	// So we can use vCmdWindow
#include <v/vmenu.h>	// For the menu pane
#include <v/vutil.h>	// For V Utilities
#include <v/vcmdpane.h> // command pane
#include <v/vstatusp.h>	// For the status pane
#include <v/vtimer.h>	// Timer
#include <v/vfilesel.h>
#include <v/vynreply.h>

#include <ctype.h>
#include <string.h>
void Delete2DCharArray(int numberString,char **&Char2DArray);
void Delete2DFloatArray(int firstDimention,float **&float2DArray);
void Delete3DFloatArray(int firstDimention,int secondDimention,float ***&float3DArray);

   static int SaveAsfilterIndex = 1;
    static char* SaveAsfilter[] =
      {
            "*",
            "*.est",              
            
        0
      };
const char markerChar = 'x';

#ifdef vDEBUG
#include <v/vdebug.h>
#endif
void sort(int ,char ** ) ;
void StrToUpper(char *);
void StrToLower(char *);
int Is_Digit(char *);
int Is_ZDigit(char *);


#include "SpeDbname.h"
#include "SpPrSave.h"
#include "SpPrdbe.h"    // Dbe 
#include "DrawCnvCmd.h"
#include "SpPrcnv.h"

//#include "FmtStaGroup.h"
#include <list>
using namespace std;
class StationGroup
{
private:
	int itsNumberStation;
protected:
	char *itsMainStation;
	list<char *> itsStationList;  
	list<char *>::iterator itsItrStationList;  
public:
   StationGroup(char *str):itsNumberStation(0){
itsMainStation = new char[strlen(str)+1];
strcpy(itsMainStation,str);
}
   virtual ~StationGroup(){
   //fprintf(stderr,"Destructor StationGroup\n");
   delete itsMainStation;
   itsStationList.clear();
};
   char* &GetMainStation()  {return itsMainStation;}
   int &GetNumberStation()  {return itsNumberStation;}
   list<char *> &GetStationList() {return itsStationList;}

};


    class FmtOriginCmdWindow;

    class FmtOriginTimer : public vTimer
      {
      public:		//---------------------------------------- public
	FmtOriginTimer(FmtOriginCmdWindow* cw) { cmdw = cw; }
	~FmtOriginTimer() {}
	virtual void TimerTick();
      private:		//--------------------------------------- private
	FmtOriginCmdWindow* cmdw;
      };

    class FmtOriginCmdWindow : public vCmdWindow
      {
	friend int AppMain(int, char**);	// allow AppMain access

      public:		//---------------------------------------- public
	FmtOriginCmdWindow(char*, int, int, int, int);
	virtual ~FmtOriginCmdWindow();
	virtual void WindowCommand(ItemVal id, ItemVal val, CmdType cType);
	virtual void KeyIn(vKey keysym, unsigned int shift);
        int filterDblClick(ItemVal , int &);
        ORIG ori;
	    char OriginName[_MAX_FILE_NAME];
	    char CausticFile[_MAX_FILE_NAME];
		void EmptyOrigin();
		void Get_StaList ();
		void Get_EventList ();

      protected:	//--------------------------------------- protected
int  N_EventList,N_StaList,N_SelStaList,N_OldSelStaList,NMainShock,N_GroupStaList;
int N_StaListForDraw;
char ** EventList;
char ** StaList;
char ** SelStaList;
char ** OldSelStaList;
char ** GroupStaList;
char ** StaListForDraw;
int IndicateSave;
float angleSelect;
	// list<char *> itsBaseStationList;  
	// list<char *>::iterator itsItrBaseStationList; 	   
        list<StationGroup *> itsStationGroupList;  
 	list<StationGroup *>::iterator itsItrStationGroupList;
 
	list<StationGroup *>::iterator itsItrCurrentStationGroupList;

 

    char ErrorReturnCode[4096];

      private:		//--------------------------------------- private
	int Ww, Hh;
	// Standard elements
	vMenuPane* FmtOriginMenu;		// For the menu bar
	vCommandPane* FmtOriginCmdPane;	// for the command pane
	vCommandPane* FmtOriginCmdPane2;	// for the command pane
	vCommandPane* FmtOriginCmdPane1;	// for the command pane
	SpePrepTextCanvasPane* FmtOriginCanvas;		// For the canvas


	vStatusPane* FmtOriginStatus;		// For the status bar
	FmtOriginTimer* _timer;	// Timer for Date/Time
	

        SpDbNameModalDialog*  SpeDbNameDialog;
         CDbeSeis *pCDbeSeis;
         CSpPrSave  *pSpPrSave; 

        char CSpPrSaveName[256];  
	char m_WorkDir[_MAX_FILE_NAME];

	// Dialogs associated with CmdWindow

int     DblEventList,DblStaList, DblSelStaList,DblOK; 
void  Set_SelStaList(char **, int);
void  Get_NewSelStaLists();
void  Save_SelStaList();
// GetProjectWfdisc(0,ErrorReturnCode):> 
// first par == 0 - draw initial site from selsta; 
//           == 1 - draw initial site from groupsta.
char* GetProjectWfdisc(int ind,char *ErrCode);
// DrawMap(ptr,0):>
// second par == 0 - draw map using only stations ,
//            != 0 - name of caustic file, draw map using stations + caustic
void  DrawMap(char *DbeName,char *caustic);
void  CreateGroups(float angleSelect);
void  Set_GroupList(char **NewList, int N);
void  ActionOnGroupList();
bool ChangeStationGroup (char *searchInGrList);
void  SetGroupListValueZero();
void  SaveGroupList();
      };
#endif
    
