C  Programme de relecture des fichiers apem pour creation de
c  fichiers colonne pour usage EOS
c
czzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz
c	The program reads the file 'list_sta' with names and
c	coordinates of stations.
c	The results - gradient models and file 'list_mod'
c	with model names to be used by program '3sama2mod'
c	for recalculating these models to homogeneous layered 
c	structures completed by homogeneous layered PREM model 
c	for depth range from 660 km (r=5711km) to 2021 km. 
czzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz
      
c
      character*10 truc
      character*7 extent
      character*80 staname

c

           include 'apem.ins'
c!!!!!!!!!!!!!!!!!!!!
c
      kdeb=119
c
c  Lecture des fichiers (c'est long !!!)
c
      write(*,*) 'WELCOME IN FORM_EOS !'
      write(*,*) 'Log and Data files written in : '
     &    //dirw(1:lnblank(dirw))//'eos'
c  Ouverture du fichier log (tjrs unite 10)
c
c      file=dirw(1:lnblank(dirw))//'eos/feos.log'
      file=dirw(1:lnblank(dirw))//'/feos.log'
      open(10,file=file)
c
c  Lecture des Rayons des interfaces chimiques
c
      do k=kmin,min(kstd-1,kmax)
        file=dirr(1:lnblank(dirr))//'radi/radi.'//car(k)
        call read_data(ny,nx,file,radius(1,1,k),titre)
      enddo
c
c  Rayons aux profondeurs standards
c
      do k=max(kmin,kstd),kmax
        do j=1,nx
          do i=1,ny
            radius(i,j,k)=rterre-depth(k)
          enddo
        enddo
      enddo
c
c  Rayons recalcules aux interfaces transition de phase
c
      do kph=1,nphase
        k=kphase(kph)
        if (k.le.kmax.and.k.ge.kmin) then
          file=dirr(1:lnblank(dirr))//'radi/radi.'//car(k)
          call read_data(ny,nx,file,radius(1,1,k),titre)
        endif
        k=k+1
        if (k.le.kmax.and.k.ge.kmin) then
          file=dirr(1:lnblank(dirr))//'radi/radi.'//car(k)
          call read_data(ny,nx,file,radius(1,1,k),titre)
        endif
      enddo
c
c  Parametres sismologiques
c
      do l=lmin,lmax
        do k=kmin,kmax
          truc=type(l)
          ln=lnblank(truc)
          file=dirr(1:lnblank(dirr))//'para/'//truc(1:ln)//'.'//car(k)
          call read_data(ny,nx,file,para(1,1,k,l),titre)
        enddo
      enddo
c
      write(*,*) 'All parameters are read'
		open(12,file='list_sta')
		open(13,file='list_mod')
			do ii=1,1000
			staname=char(0)
			read(12,1000,end=1100)staname
1000			format(a)
			read(12,*)alat, along

c 10   write(*,*) 'Enter lat and long of point to form model'
c      write(*,*) '-90<lat<90 -180<long<180'
c
c      read(*,*) alat,along
      i=lat(alat,ny)
      j=longitude(along,nx)
c      if (i.lt.1.or.i.gt.ny) goto 90
c      if (j.lt.1.or.j.gt.nx) goto 90
			if (i.lt.1.or.i.gt.ny) then
		write(*,*)'station     ',staname,'latitude is not valid!'
			stop
			end if
		if (j.lt.1.or.j.gt.nx) then
		write(*,*)'station     ',staname,'longitude is not valid!'
			stop
			end if
c      file='eos/eos'//extent(alat,along)
		file=staname(1:lnblank(staname))//'.3sm'
cc
      write(*,'(a)') file(1:lnblank(file))
	write(13,'(a)')file(1:lnblank(file))
cc
      ln=lnblank(file)
      titre=file
      file=dirw(1:lnblank(dirw))//file(1:ln)
      do k=kmin,kmax
        chose(1,k)=radius(i,j,k)*1000.
        chose(2,k)=para(i,j,k,lro)
        chose(3,k)=para(i,j,k,lvp)
        chose(4,k)=para(i,j,k,lvs)
        chose(5,k)=1.
        chose(6,k)=1.
        chose(7,k)=1.
        chose(8,k)=exp(-para(i,j,k,lqs))
        chose(9,k)=0.00002
      enddo
c !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!11     
      call write_eos(file,9,kill,kmax,chose,titre)
c      goto 10
			end do
1100			continue
		close(12)
		close(13)
c 90   write(*,*) 'lat or long not valid ! Try again'
cc     goto 10
		stop
      end
c *********************************
      integer function lat(alat,ny)
c *********************************
c  lat est l'indice en colatitude du point de latitude alat
c  (en degres de 90 a -90), sur grille a ny points en colatitude 
c
      lat=nint((90.-alat)*ny/180.+0.5)
      return
      end
c ***********************************
      integer function longitude(along,nx)
c ***********************************
c  long est l'indice en longitude du point de longitude along 
c  (en degres de -180 a 180), sur grille a nx points en longitude
c
      aalong=along
      if (along.lt.0.) aalong=along+360.
      longitude=nint(aalong*nx/360.+0.5)
      if (longitude.gt.nx) longitude=longitude-nx
      return
      end
c ****************************************************
      subroutine write_eos(file,imax,kill,kmax,chose,titre)
c ****************************************************
c  Ecrit le tableau chose(i,k) dans le fichier file, au format EOS
c  Ecrit le nom du fichier ecrit et le titre dans fichier log
c  (Unite 10)
c
c      character*80 line1,rabchar
c most ---------------------------
        character*80 rabchar
c most ---------------------------
c      data line1 /'(NLAY,MINLAY,MOHO,NOUT,NEFF,NBAND,KITI)'/
      character*(*) file,titre
c      dimension chose(imax,kmax),kill(1)
c    most  
           dimension chose(imax,kmax),kill(kmax)
      integer   kdeb,idum
c
c      kdeb=119
c      idum=1
c
c  Elimination des couches vides
c
      do k=1,kmax
        kill(k)=0
      enddo
c
    
      killed=0
      idisc=1
      k=1
 1    k=k+1
      if (k.gt.kmax) goto 10
      if (chose(1,k).eq.chose(1,k-1)) then
        if (idisc.eq.1) then
          kill(k-1)=1
          killed=killed+1
        endif
        idisc=1
      else
        idisc=0
      endif
      goto 1
c
c  Ecriture du modele
c
      
 10   open(8,file=file,err=90)
      kdeb=119
      idum=1
     
cc      write(8,'(a)') titre
      write(8,100) kmax-killed,kdeb,idum,idum,idum,idum,idum
      write(8,*)
      write(8,*)
      write(8,*)
c
 100  format(7I4)
c
      l=0
      do k=kmax,1,-1
        if (kill(k).eq.0) then
          l=l+1
          write(8,200,err=92) kdeb+l-1,(chose(i,k),i=1,imax)
        endif
      enddo
      close (8)
cc      write(10,'(a)') 'FILE WRITTEN : '//file(1:lnblank(file))
      rabchar=char(0)
      rabchar='FILE WRITTEN : '//file(1:lnblank(file))
      write(10,'(a)')rabchar
c      write(10,'(a)') '      HEADER : '//titre(1:lnblank(titre))
      return
 200  format(I4,F11.1,8D12.5)
c
cc 90   write(*,*) 'Cannot open file: '//file
 90     rabchar=char(0)
        rabchar='Cannot open file: '//file
	write(*,*)rabchar
      stop
cc 92   write(*,*) 'Problem writing in file '//file
 92     rabchar=char(0)
        rabchar='Problem writing in file '//file
	write(*,*)rabchar
      stop
      end
c  *******************************************
      character*(*) function extent(alat,along)
c ********************************************
c  Ecrit la chaine extent comme etant latlong sans blanc
c  et avec le signe
c
      character*1 icar,jcar
      integer aa,bb
c
      icar='+'
      jcar='+'
      aa=alat
      bb=along
      if (alat.lt.0.) then
        aa=-aa
        icar='-'
      endif
      if (along.lt.0.) then
        bb=-bb
        jcar='-'
      endif
      write(extent,100) icar,aa,jcar,bb
 100  format(A1,I2.2,A1,I3.3)
 
      return
      end
