C  Subroutines communes des programmes make_* de fabrication
c  du modele APEM
c
c **********************************************
      subroutine read_data(ny,nx,file,tab,titre)
c **********************************************
c  Remplit le tableau tab(ny,nx) avec les donnees du fichier file
c  et renvoie le titre titre.
c  Rale si ny et nx ne sont pas ceux du fichier
c  ou si il y a un probleme de lecture
c  Propose alors d'essayer un autre fichier, sinon stop
c  Ecrit le nom du fichier lu et le titre dans fichier log
c  (unite 10)
c
      character*(*) file,titre
      character*80 fich,rabchar
      dimension tab(ny,nx)
c
cc 1    write(*,'(a)') 'Reading '//file
 1     rabchar=char(0)
       rabchar='Reading '//file
       write(*,'(a)')rabchar
      open(7,file=file,status='old',err=90)
      read(7,'(a)',err=91,end=91) titre
      write(*,'(a)') titre
      call get_n(7,nnx,nny,ierr)
      if (ierr.ne.0) goto 93
      if (nnx.ne.nx.or.nny.ne.ny) goto 92
      read(7,'(a)')
      read(7,*,err=91,end=91) tab
      close (7)
cc      write(10,'(a)') 'FILE READ : '//file(1:lnblank(file))
      rabchar=char(0)
      rabchar='FILE READ : '//file(1:lnblank(file))
      write(10,'(a)')rabchar
cc      write(10,'(a)') '   HEADER : '//titre(1:lnblank(titre))
      rabchar=char(0)
      rabchar='   HEADER : '//titre(1:lnblank(titre))
      write(10,'(a)')rabchar
      return
c
cc 90   write(*,*) 'Problem opening '//file
 90   rabchar=char(0)
      rabchar='Problem opening '//file
      write(*,*)rabchar
 901  write(*,*) 'Another file name ? (return to abandon)'
      read(*,'(a)') fich
      if (fich.ne.'') then
        file=fich
        goto 1
      endif
      stop
cc 91   write(*,*) 'Problem reading in '//file
 91   rabchar=char(0)
      rabchar='Problem reading in '//file
      write(*,*)rabchar
      close (7)
      goto 901
 92   write(*,*) 'NX or NY not the same as in file : ',nx,ny
      write(*,'(a)') file
      close (7)
      goto 901
cc 93   write(*,*) 'Problem reading NX and NY in '//file
 93   rabchar=char(0)
      rabchar='Problem reading NX and NY in '//file
      write(*,*)rabchar
      close (7)
      goto 901
      end
c *************************************
      subroutine get_n(lu,nnx,nny,ierr)
c *************************************
c  Petite subroutine pour recuperer nx et ny de la ligne FORMAT
c  des fichiers pour plotmap
c
      character*80 ligne
c
      ierr=0
c
      read(lu,'(a)',err=9,end=9) ligne
      l=0
 1    l=l+1
      if (l.gt.len(ligne)) goto 9
      if (ligne(l:l+2).eq.'nx=') then
        read(ligne(l+3:l+6),*,err=9) nnx
        goto 2
      endif
      goto 1
 2    l=0
 3    l=l+1
      if (l.gt.len(ligne)) goto 9
      if (ligne(l:l+2).eq.'ny=') then
        read(ligne(l+3:l+6),*,err=9) nny
        return
      endif
      goto 3
c
 9    ierr=1
      return
      end
c ***********************************************
      subroutine write_data(ny,nx,file,tab,titre)
c ***********************************************
c  Ecrit le tableau tab(ny,nx) dans le fichier file, au format
c  plotmap, avec le titre titre
c  Ecrit le nom du fichier ecrit et le titre dans fichier log
c  (Unite 10)
c
      character*(*) file,titre
      dimension tab(ny,nx)
      character*80 rabchar
c
      open(8,file=file,err=90)
      write(8,'(a)') titre
      write(8,201) nx,ny
      write(8,'(a)') 'DATA'
      write(8,200,err=92) tab
      close (8)
cc      write(10,'(a)') 'FILE WRITTEN : '//file(1:lnblank(file))
      rabchar=char(0)
      rabchar='FILE WRITTEN : '//file(1:lnblank(file))
      write(10,'(a)')rabchar
cc      write(10,'(a)') '      HEADER : '//titre(1:lnblank(titre))
      rabchar=char(0)
      rabchar='      HEADER : '//titre(1:lnblank(titre))
      write(10,'(a)')rabchar
      return
 200  format(10(1x,1Pe12.5))
 201  format('FORMAT nx=',I3,' ny=',I3,' (*)')
c
cc 90   write(*,*) 'Cannot open file: '//file
 90   rabchar=char(0)
      rabchar='Cannot open file: '//file
      write(*,*)rabchar
      stop
cc 92   write(*,*) 'Problem writing in file '//file
 92   rabchar=char(0)
      rabchar='Cannot open file: '//file
      write(*,*)rabchar

      write(*,*)rabchar
      stop
      end
c ****************************************
      integer function lnblank(chaine)
c ****************************************
c  lnblank est la longueur de la chaine chaine 
c  lnblank=0 s'il n'y a que des blancs
c
      character*(*) chaine
      character*1 car
c                            
      lnblank=len(chaine)
 10   car=chaine(lnblank:lnblank)
      if (car.ne.' '.and.car.ne.char(0)) return
      lnblank=lnblank-1
      if (lnblank.gt.0) goto 10
      lnblank=0
      return
      end
c ******************************************
      subroutine wrout_data(ny,nx,tab,titre)
c ******************************************
c  Meme chose que write_data mais ecrit dans stdout
c
      character*(*) titre
      character*80 rabchar
      dimension tab(ny,nx)
c
      write(6,'(a)') titre
      write(6,201) nx,ny
      write(6,'(a)') 'DATA'
      write(6,200,err=92) tab
      write(10,'(a)') 'FILE WRITTEN IN STDOUT'
cc     write(10,'(a)') '      HEADER : '//titre(1:lnblank(titre))
      rabchar=char(0)
      rabchar='      HEADER : '//titre(1:lnblank(titre))
      write(10,'(a)')rabchar
      return
 200  format(10(1x,1Pe11.4))
 201  format('FORMAT nx=',I3,' ny=',I3,' (*)')
c
 92   write(*,*) 'Problem writing in stdout'
      stop
      end
