      subroutine flat(h,ro,vp,vs,n,kind)
c     subroutine applies earth-flattening corrections by
c     scaling the model.for reference see Biswas 1972.
c     kind=1 for Love wave calculations
c     kind=2 for Rayleigh wave calculations
      implicit real*8(a-h,o-z)
      real*8 h(100),ro(100),vp(100),vs(100)
      data a/6371.d0/
      pwr=2.275d0
      if(kind.eq.1) pwr=5.d0
      nm=n-1
      hs=0.d0
      do 5 i=1,n
      ht=hs
      hs=hs+h(i)
    5 h(i)=a-ht
      do 10 i=1,nm
      ii=i+1
      fltd=dlog(h(i)/h(ii))
      dif=(1.d0/h(ii)-1.d0/h(i))*a/fltd
      difr=h(i)**pwr-h(ii)**pwr
      ro(i)=ro(i)*difr/(fltd*(a**pwr)*pwr)
      vp(i)=vp(i)*dif
   10 vs(i)=vs(i)*dif
c half space scaling
      fact=a/h(n)
      vp(n)=vp(n)*fact
      vs(n)=vs(n)*fact
      ro(n)=ro(n)*(1.d0/fact)**pwr
      z0=0.d0
      do 15 i=2,n
      z1=a*dlog(a/h(i))
      h(i-1)=z1-z0
   15 z0=z1
      h(n)=0.d0
      return
      end
