//
// C++ Implementation: creationdb
//
// Description:
//
//
// Author: fmt <fmt@localhost.localdomain>, (C) 2008
//
// Copyright: See COPYING file that comes with this distribution
//
//

#include <QtGui>
#include "mainwindow.h"
#include "appkonsole.h"
#include "document.h"
#include "default.h"
#include <fstream>
#include <iostream>
void error(QString s, QString s2 );
void error(QString s, QString s2 ) {
    QString tmp = s;
    tmp = tmp + " ";
    tmp = tmp + s2;
    QMessageBox::critical(0,mainWindowCaption(),tmp);

}
bool CopyFile(QString &source,QString &distination);
bool CopyFile(QString &source,QString &distination) {
    ofstream outfile(distination.toAscii(), ios::binary | ios::out);
    if (!(outfile)) {
        error(QString("cannot open output file"),distination);
        return false;
    }
    fstream in(source.toAscii(),ios::binary | ios::in);
    if (!(in)) {
        error(QString("cannot open input file"),source);
        return false;
    }
    outfile << in.rdbuf();
    outfile.close();
    in.close();
    return true;
}
///========================================================================================
ProcessKonsole::~ProcessKonsole() {
};
ProcessKonsole::ProcessKonsole(QWidget* parent,ProcessType type)
        : QProcess(),parent(parent),type(type) {
    setProcessChannelMode(QProcess::MergedChannels);

    connect(this, SIGNAL( readyReadStandardOutput () ), this, SLOT(ReadStandardOutput ()));
    connect(this, SIGNAL( readyReadStandardError () ), this, SLOT(ReadStandardError ()));

//    connect(this, SIGNAL( readyRead () ), this, SLOT(ReadyRead ()));
}
void ProcessKonsole::ReadyRead() {
    AppKonsole* wd = (AppKonsole*) parent;
    wd->SetStandardOutput(readAllStandardOutput ());
}
void ProcessKonsole::ReadStandardOutput() {
    AppKonsole* wd = (AppKonsole*) parent;
    QByteArray bytearray = readAllStandardOutput ();
    wd->SetStandardOutput(bytearray);
//    if (type == SeedToAh) wd->SetProgressSeedToAh(bytearray);
}
void ProcessKonsole::ReadStandardError() {
    AppKonsole* wd = (AppKonsole*) parent;
    QByteArray bytearray = readAllStandardError ();
    wd->SetStandardOutput(bytearray);
//    if (type == SeedToAh) wd->SetProgressSeedToAh(bytearray);
}
bool ProcessKonsole::StartProcess(const QString & name,const QString & program, const QString & workingDirectory,const QStringList & arguments) {
    setWorkingDirectory (workingDirectory);
    QStringList environment = QProcess::systemEnvironment();
    setEnvironment(environment);

    start (program,arguments);

    if (!waitForStarted()) {
        QMessageBox::warning ( 0,name + "process",
                               tr ( "The process %1 was not started." )
                               .arg (name));
        return false;
    }

    if (!waitForFinished()) {
        QMessageBox::warning ( 0,name + "process",
                               tr ( "The process %1 was not finished." )
                               .arg (name));
        return false;
    }

    return true;
}
///=====================================================================================
AppKonsole::~AppKonsole() {
    if (proc != 0) {
        delete proc;
        proc = 0;
    }
}
AppKonsole::AppKonsole(QWidget* parent)
        : QTextEdit(parent) {

    QFont f = parent->font();
    setFont( f );
    proc = 0;
}
void AppKonsole::SetDateTimeKonsole(MDocument* dc) {
    doc = dc;
    clear ();
    QString tmp = QString();
    QDateTime dt =  QDateTime::currentDateTime ();
    QString date = QString("%1\n\n").arg( dt.toString(Qt::ISODate));
    date.replace('-','/');
    date.replace('T',' ');
    tmp +="MomTens program konsole created on " + date;

    setAlignment ( Qt::AlignRight );//Qt::AlignCenter
    setTextColor (QColor("darkBlue") );
    textCursor().insertText(tmp);
    setAlignment (Qt::AlignLeft);
    setTextColor (QColor("black") );
    tmp = "Project location:\n";
    if (MainWindow::self->GetCurFile().isEmpty() )
        tmp += "unnamed";
    else
        tmp += MainWindow::self->GetCurFile();
    tmp += "\n";
    textCursor().insertText(tmp);
    ensureCursorVisible ();
}
void AppKonsole::SetStandardOutput(const QByteArray & outputArray) {
    textCursor().insertText(outputArray.data());
}


bool AppKonsole::PolaritySmoothingProcess(const QString & program, const QString & workingDirectory,const QStringList & arguments,float depth,float vpsource,float an) {
// QMessageBox::warning(0,"",QString("%1  %2").arg(program).arg(workingDirectory));


    QString  name = "Smoothing polarity:\n";

//   QString tmp1 = "";
//    for (int j = 0; j < arguments.size(); ++j) tmp1 += arguments.at(j) + "\n";
//    QMessageBox::warning(this,"",QString(" %1").arg(tmp1));

    textCursor().insertText(name);


    if (proc != 0) {
        delete proc;
        proc = 0;
    }

    proc = new ProcessKonsole(this,ProcessKonsole::Polarity);

    if (!proc->StartProcess(name,program, workingDirectory,arguments)) {
        return false;
    }

    QString tmp = QString("depth: %1 , vpsource: %2 , smoothing andle: %3 .\n").
                  arg(depth).
                  arg(vpsource).
                  arg(an);
    textCursor().insertText(tmp);
    ensureCursorVisible ();

    return true;
}
bool AppKonsole::Get3SmacModels() {
    QString name = "Programme de relecture des fichiers apem pour creation de fichiers colonne pour usage EOS";
    QString program= "/opt/fmt/bin/form_eos";
    QStringList arguments = QStringList();
    QString workingDirectory = MainWindow::self->tempDirectoryPath;

    if (proc != 0) {
        delete proc;
        proc = 0;
    }
    proc = new ProcessKonsole(this,ProcessKonsole::Polarity);

    if (!proc->StartProcess(name,program, workingDirectory,arguments)) {
        return false;
    }
    name = "The program recalculates the crust models obtained by 3smak program";
    program= "/opt/fmt/bin/3sma2mod";

    if (proc != 0) {
        delete proc;
        proc = 0;
    }
    proc = new ProcessKonsole(this,ProcessKonsole::Polarity);

    if (!proc->StartProcess(name,program, workingDirectory,arguments)) {
        return false;
    }

    ensureCursorVisible ();
    return true;
}
