	SUBROUTINE AZIDMOD (SLAT0,SLON0,ELAT0,ELON0,DEL,DELS,AZIS,
     *	AZIE,SHIFT) 
c--------------------------------------------------------------------
c	The program calculates DEL and DELS for elliptical (AZIDEL)
c	and spherical Earth (DELAZ), and if one of the differences 
c	exceeds 2% the station latitude is reducing by 0.01 degree. 
c	This procedure is repeating while the differences become less
c	then 2%. The final values of parameters are calculated by
c	AZIDEL. The total reduction of station latitude is given by
c	SHIFT in degrees.
c--------------------------------------------------------------------
	slat=slat0
	slon=slon0
	elat=elat0
	elon=elon0  
	pi=3.1415926	
	shift=0.
		if((slat*sign(1.,slat)).gt.(pi/2.-0.01*pi/180.)) then
		slat=slat-0.01*pi/180.*sign(1.,slat)
		slon=elon
		shift=-0.01*sign(1.,slat)
		end if
	if((elat*sign(1.,elat)).gt.(pi/2.-0.01*pi/180.)) then
	elat=elat-0.01*pi/180.*sign(1.,elat)
	elon=slon
	end if
2		continue
	call AZIDEL (SLAT,SLON,ELAT,ELON,DEL,DELS,AZIS,AZIE)
	call DELAZ (elat,elon, slat,slon, del1,azie1)
	call DELAZ (slat,slon, elat,elon, del1,azis1)
	dels1=del1*6371.
	r1=abs((del1-del)/del)
	r2=abs((dels1-dels)/dels)
		if(r1.gt.0.02.or.r2.gt.0.02) then
		slat=slat-0.01*pi/180.
		shift=shift+0.01
		go to 2
		end if
						RETURN
                                                END
czzzzzzzzzzzzzzzzzzzzzzz  in Cochann.lib : AZIDEL  zzzzzzzzzzzzzzzzzzzzz
	subroutine AZIDEL (SLAT,SLON,ELAT,ELON,DEL,DELS,AZIS,AZIE)
czzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz
		real*4 SLAT,SLON,ELAT,ELON,DEL,DELS,AZIS,AZIE
c-----------------------------------------------------------------------
c						from "azidel"-programm
C     AZIS IS AZIMUTH FROM STATION, AZIE FROM EPICENTRUM, DEL - ANGULAR
C     DISTANCE FROM EPICENTRUM TO THE STATION, DELS IS THE DISTANCE OVER
C     THE SURFACE OF AN ELLIPSOIDAL EARTH (IN KM), CALCULATED WITH FORM 
C     29 OF THOMAS, JGR 70, PP 3331-3340, 1965 .
C     ALL ANGLES - IN RAD.
c-----------------------------------------------------------------------
      COLAT(A)=1.57079632679-ATAN(.993277*TAN(A)) 
      SCOLAT=COLAT(SLAT)
      ECOLAT=COLAT(ELAT)
      SC1=SIN(SCOLAT) 
      SC2=COS(SCOLAT) 
      SC3=SIN(SLON) 
      SC4=COS(SLON) 
      EC1=SIN(ECOLAT) 
      EC2=COS(ECOLAT) 
      EC3=SIN(ELON) 
      EC4=COS(ELON) 
      AE=EC1*EC4
      BE=EC1*EC3
      AZI1=(AE-SC3)**2+(BE+SC4)**2+EC2*EC2-2. 
      AZI2=(AE-SC2*SC4)**2+(BE-SC2*SC3)**2+(EC2+SC1)**2-2.
      IF(AZI2.EQ.0.) GO TO 10 
      AZIS=ATAN2(AZI1,AZI2) 
      GO TO 20
   10 AZIS=3.141592653-SIGN(1.1570796326,AZI1)
   20 CODELB=SC1*(AE*SC4+BE*SC3)+SC2*EC2
      DEL=ACOS(CODELB)
      AS=SC1*SC4
      BS=SC1*SC3
      AZI1=(AS-EC3)**2+(BS+EC4)**2+SC2*SC2-2. 
      AZI2=(AS-EC2*EC4)**2+(BS-EC2*EC3)**2+(SC2+EC1)**2-2.
      IF(AZI2.EQ.0.) GO TO 30 
      AZIE=ATAN2(AZI1,AZI2) 
      GO TO 40
   30 AZIE=3.141592653-SIGN(1.1570796326,AZI1)
   40 SCOLAT=1.57079632679-SLAT 
       ECOLAT=1.57079632679-ELAT
      SC1=SIN(SCOLAT) 
      SC2=COS(SCOLAT) 
      EC1=SIN(ECOLAT) 
      EC2=COS(ECOLAT) 
      AE=EC1*EC4
      BE=EC1*EC3
      DELBOD=ACOS(SC1*(AE*SC4+BE*SC3)+SC2*EC2)
      COSDEL=COS(DELBOD)
      X1=((SC2+EC2)**2)/(1.+COSDEL) 
      X2=((SC2-EC2)**2)/(1.-COSDEL) 
      X=X1+X2 
      Y=X1-X2 
      COTDEL=1./TAN(DELBOD) 
      SINDEL=SIN(DELBOD)
      DEL2=DELBOD*DELBOD
      A=64.*DELBOD+16.*DEL2*COTDEL
      D=48.*SINDEL+8.*DEL2/COSDEL 
      B=-(D+D)
      E=30.*SIN(DELBOD+DELBOD)
      C=-30.*DELBOD-8.*DEL2*COTDEL-E/2. 
      DELS=6378.2064*(DELBOD-.000847518825*(X*DELBOD-3.*Y*SINDEL)+.08978
     #60195E-6*(X*(A+C*X+D*Y)+Y*(B+E*Y))) 
								RETURN
								END 

c///////////////////////////////////////////////////////////////////////
c--------------------------------------------- in Cochann.lib : DELAZ
        subroutine DELAZ (plat,plon, slat,slon, del,az)
c-----------------------------------------------------------------------
                real*4 plat,plon,slat,slon,del,az
c-----------------------------------------------------------------------
c	     SPHERICAL delta-azimuth ( from (plat,plon) to (slat,slon) )

c					    INPUT and OUTPUT in RADIANS
c						output az - [0,pi2)
c-----------------------------------------------------------------------
	pi=3.1415926	
						   dlon=slon-plon
					sdlo  =SIN(dlon)
						   dlon=dlon/2.
					sdlohs=SIN(dlon)**2

					sdlahs=SIN((slat-plat)/2.)**2
					cslahs=COS((slat+plat)/2.)**2

				   cdel=sdlahs+sdlohs*(cslahs-sdlahs)
	delt=2.*ASIN(AMIN1(1.,SQRT(cdel)))
				   cdel=1.-2.*cdel
				   sdel=SIN(delt)
	 		azt=0.
			       if (sdel.gt.0.) then
c		    ...................................
					  splat=SIN(plat)
					  sslat=SIN(slat)
					  cslat=COS(slat)
				 azt=sdlo*cslat/sdel
				 azt=ASIN(SIGN(AMIN1(abs(azt),1.),sdlo))
c  !!!! it was:			 azt=ASIN(SIGN(AMIN1(azt,1.),sdlo))
	if (sslat.lt.splat*cdel) azt=pi-azt
		  if (azt.lt.0.) azt=azt+2.*pi
c		    ...................................
			       end if
	del=delt
	az =azt
								RETURN
								END

