#include <QtGui>
#include <QApplication>
#include <QMessageBox>
#include "mainwindow.h"
#include  <math.h>
#include <default.h>
QString M0MTENS_ROOT_PATH;
QString M0MTENS_SEARCH_HELP_PATH;
void tryRemoveYesterdayWorkingMaterials();
int main(int argc, char *argv[])
{
	Q_INIT_RESOURCE(momtens);
 
	QApplication app(argc, argv);
	app.setStyle(QStyleFactory::create("plastique"));
	QApplication::setPalette(QApplication::style()->standardPalette());
	QString absoluteInstallEcpPath = app.applicationDirPath();
	int pos = absoluteInstallEcpPath.lastIndexOf("/bin");
	absoluteInstallEcpPath.remove ( pos, 4 );
	M0MTENS_ROOT_PATH = absoluteInstallEcpPath;
#if defined(Q_WS_WIN)
	M0MTENS_SEARCH_HELP_PATH = "file:///" + M0MTENS_ROOT_PATH + "/doc";
#endif
#if defined(Q_WS_X11)
	M0MTENS_SEARCH_HELP_PATH = "file://" + M0MTENS_ROOT_PATH + "/doc";
#endif
#if defined(Q_WS_MAC)
	M0MTENS_SEARCH_HELP_PATH = "file://" + M0MTENS_ROOT_PATH + "/doc";
#endif
	tryRemoveYesterdayWorkingMaterials();
	MainWindow mainWin;
	mainWin.show();
	return app.exec();
}

void tryRemoveYesterdayWorkingMaterials()
{

    QDir tempDir(temporarySystemDirectoryPath());
    QFileInfoList info = tempDir.entryInfoList (QDir::Dirs,QDir::Name);

    for (int i = 0; i < info.size(); ++i)
    {
        QString curAbsoluteFilePath =  QDir::toNativeSeparators(info.at(i).absoluteFilePath());
        if (curAbsoluteFilePath.contains(temporaryDirectoryPrifix()) )
        {
            QString str =  curAbsoluteFilePath.section("-",1,1);
            uint fileTime_t = str.toUInt();
            QDate date = QDate::currentDate ();
            QTime time = QTime::currentTime ();
            QDateTime datetime (date, time ) ;
            uint currentTime_t = datetime.toTime_t ();
            if ((currentTime_t - fileTime_t) > (uint) (86400))
            {
                MainWindow::self->removeWorkingMaterials(curAbsoluteFilePath);
            } 
        }
    }

}

