#include <qwt_math.h>
//#include <qwt_scldiv.h>
#include <qwt_plot_canvas.h>
#include <qwt_plot_layout.h>
#include <qwt_paint_buffer.h>
#include <qwt_plot_grid.h>
#include <qwt_plot_curve.h>
#include <qwt_plot_marker.h>
///////////////////////////////////////
#include <qwt_plot_printfilter.h>
#include <qrect.h>
//#include <qwt_dimap.h>
//#include <qwt_plot_classes.h>
///////////////////////////////////////
#include <qframe.h>
#include <qpen.h>
#include <qcursor.h>
#include <qcolor.h>
#include <qpainter.h>
#include <qbrush.h>
#include <qfont.h>
#include <qsize.h>
#include <qregion.h>
//#include <q3memarray.h>
#include <qstatusbar.h>

#include <qwt_plot_picker.h>
////////////////////////////////////////
#include <qfile.h>
#include <qfileinfo.h>
#include <qtextstream.h>
#include <qstringlist.h>
#include <qmessagebox.h>
//Added by qt3to4:
#include <float.h>
#include <math.h>

#include "mainwindow.h"
#include "default.h"
#include "bode_plot.h"
#include "bode.h"
#include "dataset.h"

//-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
BodePlot::~BodePlot()
{

}
//-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
CdScaleDraw::CdScaleDraw ( QColor col ) : QwtScaleDraw(),color ( col ) {}
void CdScaleDraw::draw ( QPainter *p, const QPalette &pal ) const
{
	p->setPen ( QColor ( color ) );
	QwtScaleDraw::draw ( p,pal );

}
//-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
void   BodePlot::printCanvas ( QPainter *p, const QRect &br,const QRect &r, const QwtScaleMap m[axisCnt], const QwtPlotPrintFilter & f ) const
{
//qWarning("x %d y %d w %d h %d",r.x(),r.y(),r.width(),r.height());
//QMessageBox::about(0,"","printCanvas");
	int a11 = m[0].transform ( m[0].s1() );
	int a12 = m[0].transform ( m[0].s2() );
	// qWarning("XXXX a11 %d a12 %d",a11,a12);
//int a21 = m[1].i1();
//int a22 = m[1].i2();
	/// qWarning("XXXX a21 %d a22 %d",a21,a22);
	int a31 = m[2].transform ( m[2].s1() );
	int a32 = m[2].transform ( m[2].s2() );
	// qWarning("XXXX a31 %d a32 %d",a31,a32);
//int a41 = m[3].i1();
//int a42 = m[3].i2();
	//qWarning("XXXX a41 %d a42 %d",a41,a42);

//p->drawLine(a31,a11,a31 ,a12);

//qWarning("x %d y %d w %d h %d",r.x(),r.y(),r.width(),r.height());



	QwtPlot::printCanvas ( p, br,r, m, f );
	QPen oldPen1 = p->pen();
	p->setPen ( QPen ( Qt::black ) );
	//p->drawRect(r);
	p->drawLine ( a31,a11,a31 ,a12 );
	p->drawLine ( a32,a11,a32 ,a12 );
	p->drawLine ( a31,a12,a32 ,a12 );
	p->drawLine ( a31,a11,a32 ,a11 );


	p->setPen ( QPen ( Qt::lightGray ) );
	p->drawRect ( r );
	p->drawLine ( r.right(),r.top(),r.right(),r.bottom() );
	p->drawLine ( r.left(),r.bottom(),r.right(),r.bottom() );
	p->setPen ( oldPen1 );
}

//------------------------------------------------------------------------------------------------------------------------------
DurationPlot::~DurationPlot() {}
DurationPlot::DurationPlot ( QWidget *parent,CDataSet* data, CDataInfo* dataInfo,const QString name,bool prn ) :
		BodePlot ( parent,data,dataInfo,name,prn )
{

	replot();
}
//------------------------------------------------------------------------------------------------------------------------------
MajorAxisPlot::~MajorAxisPlot() {}
MajorAxisPlot::MajorAxisPlot ( QWidget *parent,CDataSet* data, CDataInfo* dataInfo,const QString name,bool prn ) :
		BodePlot ( parent,data,dataInfo,name,prn )
{
	replot();
}

//------------------------------------------------------------------------------------------------------------------------------
MinorAxisPlot::~MinorAxisPlot() {}
MinorAxisPlot::MinorAxisPlot ( QWidget *parent,CDataSet* data, CDataInfo* dataInfo,const QString name,bool prn ) :
		BodePlot ( parent,data,dataInfo,name,prn )
{
	replot();
}
//------------------------------------------------------------------------------------------------------------------------------
CentroidPlot::~CentroidPlot() {}
CentroidPlot::CentroidPlot ( QWidget *parent,CDataSet* data, CDataInfo* dataInfo,const QString name,bool prn ) :
		BodePlot ( parent,data,dataInfo,name,prn )
{
	replot();
}

//------------------------------------------------------------------------------------------------------------------------------
MajorStrikePlot::~MajorStrikePlot() {}
MajorStrikePlot::MajorStrikePlot ( QWidget *parent, CDataSet* data, CDataInfo* dataInfo,const QString name,bool prn ) :
		BodePlot ( parent,data,dataInfo,name,prn )
{
	replot();
}
//------------------------------------------------------------------------------------------------------------------------------
VelocityStrikePlot::~VelocityStrikePlot() {}
VelocityStrikePlot::VelocityStrikePlot ( QWidget *parent,CDataSet* data, CDataInfo* dataInfo,const QString name,bool prn ) :
		BodePlot ( parent,data,dataInfo,name,prn )
{
	replot();
}
//-----------------------------------------------------------------------------------------------------------------------------
BodePlot::BodePlot ( QWidget *parent,CDataSet* data, CDataInfo* dataInfo,const QString name,bool prn ) :
		QwtPlot ( parent ),data ( data ),dataInfo ( dataInfo ), prn ( prn )
{
	setMargin ( 10 );

	QPalette pl = MainWindow::self->palette();
	QBrush br = pl.window();
	setCanvasBackground ( br.color() );
	// enableLegend(false);

	QwtPlotGrid *grid = new QwtPlotGrid;
	grid->enableXMin ( true );
	grid->enableYMin ( true );
	grid->setMajPen ( QPen ( Qt::darkGray, 0, Qt::DotLine ) );
	grid->setMinPen ( QPen ( Qt::lightGray, 0 , Qt::DotLine ) );
	grid->attach ( this );

	vector<CDoubleData* >::iterator iter = data->GetDoubleData().begin();


	QStringList lst = momentTensorLocatorFileName().split ( ' ', QString::SkipEmptyParts );
	if ( ( *iter )->GetFileName().toLower().contains ( lst.at ( 0 ) ) )
		titleYAxis = "Duration, s";
	if ( ( *iter )->GetFileName().toLower().contains ( lst.at ( 1 ) ) )
		titleYAxis = "Major axis length, km";
	if ( ( *iter )->GetFileName().toLower().contains ( lst.at ( 2 ) ) )
		titleYAxis = "Minor axis length, km";
	if ( ( *iter )->GetFileName().toLower().contains ( lst.at ( 3 ) ) )
		titleYAxis = "Average instant centroid velocity, km/s";
	if ( ( *iter )->GetFileName().toLower().contains ( lst.at ( 4 ) ) )
		titleYAxis = "Major axis - strike axis angle, deg";
	if ( ( *iter )->GetFileName().toLower().contains ( lst.at ( 5 ) ) )
		titleYAxis = "Velocity - strike axis angle, deg";




	QwtPlotCurve * crv1 = new QwtPlotCurve();
//   setCurveXAxis(crv1, QwtPlot::xBottom);
//    setCurveYAxis(crv1, QwtPlot::yLeft);

	crv1->setData ( ( *iter )->GetX(), ( *iter )->GetY(), ( *iter )->GetSize() );

	QPen penCurve;
	penCurve.setColor ( "blue" );
	penCurve.setWidth ( 2 );
	crv1->setPen ( penCurve );
	crv1->attach ( this );

	if ( prn )
	{
		setCanvasBackground ( QColor ( Qt::white ) );
		setCanvasLineWidth ( 0 );
	}


	//////////////////////////////////////////// X Axis ////////////////////////////////////////////////////////

	setAxisScale ( xBottom, ( *iter )->GetMinX(), ( *iter )->GetMaxX() );


//    if (ax->GetPrec()->GetValue() != "auto")    {
//	setAxisLabelFormat(xBottom,'f',ax->GetPrec()->GetValue().toInt());

//    }

	CdScaleDraw* cdXAxis = new CdScaleDraw ( br.color() );
	setAxisScaleDraw ( xBottom, cdXAxis );



//	setAxisLabelFormat(yLeft,'f',ax->GetValuePrec()->GetValue().toInt());

	int prec = 3;//ax->GetValuePrec()->GetValue().toInt();
	double optmin = ( *iter )->GetMinY();
	double optmax = ( *iter )->GetMaxY();
	optmin = ( double ) ( ( int ) ( optmin * pow ( 10., ( double ) prec ) ) * pow ( 10.,- ( double ) prec ) );
	optmax = ( double ) ( ( int ) ( optmax* pow ( 10., ( double ) prec ) ) * pow ( 10.,- ( double ) prec ) );
	QString nstep = "5";//ax->GetStepPrec()->GetValue();
	double delta1 = ( optmax - optmin ) /nstep.toInt(); // (optmax - optmin)/4;
	double a = optmin / delta1;
	int n = ( int ) ( a );
	if ( n == 0 ) n =1;
	double optstep = optmin / n;

//	qWarning(" prec %d optmin %f optmax %lf  optstep %lf n %d nstep '%s' ",prec,optmin,optmax,optstep,n,nstep.ascii());

	setAxisScale ( yLeft, optmin, optmax,optstep );


	CdScaleDraw* cdYAxis = new CdScaleDraw ( br.color() );
	//  cdYAxis->setScale((*iter)->GetMinY(),  (*iter)->GetMaxY(), 8,5, 0.048); //(*iter)->GetMaxY() - (*iter)->GetMinY()/5
	setAxisScaleDraw ( yLeft, cdYAxis );


	if ( !prn )
	{

		// marker vertical

		mrk1 =  new QwtPlotMarker();
		mrk1->setLineStyle ( QwtPlotMarker::VLine );
		mrk1->setValue ( ( *iter )->GetMinX(), ( *iter )->GetMaxY() );
		mrk1->setLabelAlignment ( Qt::AlignBottom|Qt::AlignTop );
		mrk1->setLinePen ( QPen ( Qt::gray, 0, Qt::DotLine ) );

		mrk3 =  new QwtPlotMarker();
		mrk3->setLineStyle ( QwtPlotMarker::VLine );
		mrk3->setValue ( ( *iter )->GetMaxX(), ( *iter )->GetMaxY() );
		mrk3->setLabelAlignment ( Qt::AlignBottom|Qt::AlignTop );
		mrk3->setLinePen ( QPen ( Qt::gray, 0, Qt::DotLine ) );


		// marker  horizintal  top bottom
		mrk2 =   new QwtPlotMarker();
		mrk2->setLineStyle ( QwtPlotMarker::HLine );
		mrk2->setValue ( ( *iter )->GetMaxX(), ( *iter )->GetMaxY() );
		mrk2->setLabelAlignment ( Qt::AlignBottom|Qt::AlignRight );
		mrk2->setLinePen ( QPen ( Qt::gray, 0, Qt::DotLine ) ); // DashDotLine Qt::SolidLine

		mrk4 =   new QwtPlotMarker();
		mrk4->setLineStyle ( QwtPlotMarker::HLine );
		mrk4->setValue ( ( *iter )->GetMaxX(), ( *iter )->GetMinY() );
		mrk4->setLabelAlignment ( Qt::AlignBottom|Qt::AlignRight );
		mrk4->setLinePen ( QPen ( Qt::gray, 0, Qt::DotLine ) );

		//   mrkMin
		/*
		    mrkMin = insertLineMarker("", QwtPlot::yLeft);
		    setMarkerLineStyle(mrkMin, QwtMarker::VLine);
		    setMarkerPos(mrkMin, 0.0,0.0);
		    setMarkerLabelAlign(mrkMin, AlignRight|AlignBottom);
		    setMarkerPen(mrkMin, QPen(blue, 0, DashDotLine));
		    setMarkerFont(mrkMin, QFont("Helvetica", 10, QFont::Bold));

		    show3dB((*iter)->GetMinY());
		    */
	}
	pickerDuration = new QwtPlotPicker ( QwtPlot::xBottom, QwtPlot::yLeft,
	                                     QwtPicker::PointSelection | QwtPicker::DragSelection,
	                                     QwtPlotPicker::CrossRubberBand, QwtPicker::AlwaysOn,
	                                     canvas() );
	pickerDuration->setRubberBandPen ( QColor ( Qt::black ) );
	pickerDuration->setTrackerPen ( QColor ( Qt::blue ) );
	if ( prn )
	{
		QFont fn = parent->font();
		ChangeFont ( fn );
	}
//connect(pickerDuration, SIGNAL(moved(const QPoint &)),
//	SLOT(movedDuration(const QPoint &)));
//connect(pickerDuration, SIGNAL(selected(const Q3PointArray &)),
//	SLOT(selectedDuration(const Q3PointArray &)));

}
void BodePlot::ChangeFont ( QFont& f )
{
	QFont AxisFont = f;
	AxisFont.setPointSize ( AxisFont.pointSize() + 1 );
	AxisFont.setBold ( true );
	if ( prn ) AxisFont.setBold ( false );
	QwtText qtext ( "" );
	qtext.setFont ( AxisFont );
	qtext.setColor ( Qt::darkBlue );

	if ( prn ) qtext.setColor ( Qt::black );

	setAxisFont ( QwtPlot::xBottom,f );
	setAxisFont ( QwtPlot::yLeft,f );
	setAxisFont ( QwtPlot::yRight,f );

	qtext.setText ( "Residual" );
	setAxisTitle ( yLeft, qtext );
	qtext.setText ( titleYAxis );
	setAxisTitle ( xBottom, qtext );
	//setTitle(qtext);
}
/*
void BodePlot::show3dB(double freq)
{
    QString label;
    label.sprintf("    %.3g", freq);

    setMarkerPos(mrkMin, freq, 0.0);
    setMarkerLabelText(mrkMin, label);
}
*/

void BodePlot::showInfoDuration ( QString text )
{

	if ( text == QString::null )
	{
		if ( pickerDuration->rubberBand() )
			text = "Cursor Pos: Press left mouse button in plot region";
		// else
		//  text = "Zoom: Press mouse button and drag";
	}

//	MainWindow::self->statusBar()->message ( text );

}

