#include <QtGui>
#include <QMessageBox>
#include "mainwindow.h"
#include  <math.h>
#include <default.h>
QString M0MTENS_ROOT_PATH;
QString M0MTENS_SEARCH_HELP_PATH;
int main(int argc, char *argv[]) {
    Q_INIT_RESOURCE(secmom);

    QApplication app(argc, argv);
    if ( argc < 2) {
        QMessageBox::critical(0,mainWindowCaption(),"usage: mplot \"data directory\"");
        return 1;
    }

    QString dirName = QString(argv[1]);

    if (!(QFileInfo (dirName).isDir())) {
        QMessageBox::critical(0,mainWindowCaption(),
                              QString("Directory '%1' does not exist").arg(dirName),
                              QMessageBox::Close);
        return 1;
    }

    QDir tempDir(dirName);
    tempDir.setFilter(QDir::Files | QDir::NoSymLinks);
    QFileInfoList infolist = tempDir.entryInfoList();

    QStringList lst = momentTensorLocatorFileName().split(' ', QString::SkipEmptyParts);
        bool epsamtExist = false;
        bool epsamlmxExist = false;
        bool epsamlmnExist = false;
        bool epsamvExist = false;
        bool epsamfilExist = false;
        bool epsamfivExist = false;
        for ( int j = 0; j < infolist.size(); ++j ) {
            QFileInfo  infoCurTemp = infolist.at ( j );
            QString fileName = infoCurTemp.filePath().toLower();
            if ( fileName.contains (QDir::toNativeSeparators ( "/." )) ) continue;
            if ( fileName.contains ( QDir::toNativeSeparators ("/.." )) ) continue;
            if ( fileName.toLower().contains ( lst.at(0)) ) epsamtExist = true;
            if ( fileName.toLower().contains ( lst.at(1)) ) epsamlmxExist = true;
            if ( fileName.toLower().contains ( lst.at(2)) ) epsamlmnExist = true;
            if ( fileName.toLower().contains ( lst.at(3)) ) epsamvExist = true;
            if ( fileName.toLower().contains ( lst.at(4)) ) epsamfilExist = true;
            if ( fileName.toLower().contains ( lst.at(5)) ) epsamfivExist = true;

        }

        if (!epsamtExist && !epsamlmxExist && !epsamlmnExist && !epsamvExist && !epsamfilExist && !epsamfivExist) {
            QMessageBox::critical(0,mainWindowCaption(),
                                  QString("Directory '%1' does not contain drawing marerials").arg(dirName),
                                  QMessageBox::Close);
            return 1;

        }
        if (!epsamtExist) {
            QMessageBox::critical(0,mainWindowCaption(),
                                  QString("Directory '%1' does not contain file epsamt for drawing").arg(dirName),
                                  QMessageBox::Close);
            return 1;

        }
        if (!epsamlmxExist) {
            QMessageBox::critical(0,mainWindowCaption(),
                                  QString("Directory '%1' does not contain file epsamlmx for drawing").arg(dirName),
                                  QMessageBox::Close);
            return 1;

        }
        if (!epsamlmnExist) {
            QMessageBox::critical(0,mainWindowCaption(),
                                  QString("Directory '%1' does not contain file epsamlmn for drawing").arg(dirName),
                                  QMessageBox::Close);
            return 1;

        }
        if (!epsamvExist) {
            QMessageBox::critical(0,mainWindowCaption(),
                                  QString("Directory '%1' does not contain file epsamv for drawing").arg(dirName),
                                  QMessageBox::Close);
            return 1;

        }
        if (!epsamfilExist) {
            QMessageBox::critical(0,mainWindowCaption(),
                                  QString("Directory '%1' does not contain file epsamfil for drawing").arg(dirName),
                                  QMessageBox::Close);
            return 1;

        }
        if (!epsamfivExist) {
            QMessageBox::critical(0,mainWindowCaption(),
                                  QString("Directory '%1' does not contain file epsamfiv for drawing").arg(dirName),
                                  QMessageBox::Close);
            return 1;

        }


    app.setStyle(QStyleFactory::create("plastique"));
    QApplication::setPalette(QApplication::style()->standardPalette());
    QString absoluteInstallEcpPath = app.applicationDirPath();
    int pos = absoluteInstallEcpPath.lastIndexOf("/bin");
    absoluteInstallEcpPath.remove ( pos, 4 );
    M0MTENS_ROOT_PATH = absoluteInstallEcpPath;
#if defined(Q_WS_WIN)
    M0MTENS_SEARCH_HELP_PATH = "file:///" + M0MTENS_ROOT_PATH + "/doc";
#endif
#if defined(Q_WS_X11)
    M0MTENS_SEARCH_HELP_PATH = "file://" + M0MTENS_ROOT_PATH + "/doc";
#endif
#if defined(Q_WS_MAC)
    M0MTENS_SEARCH_HELP_PATH = "file://" + M0MTENS_ROOT_PATH + "/doc";
#endif


    MainWindow mainWin(dirName);
    mainWin.show();
    return app.exec();
}
