#ifndef MAINWINDOW_H
#define MAINWINDOW_H
#include <QMainWindow>
#include <QString>
#include <QDir>
#include <qwt_plot_printfilter.h>
#include <vector>
using namespace std;
class QAction;
class QMenu;
class QToolBar;
class QComboBox;
class CDataSet;
class CDataInfo;
class GraphWin;

typedef vector< vector<CDataSet* >::iterator >::iterator itPlot;
class MainWindow : public QMainWindow {
    Q_OBJECT

public:
    MainWindow(QString &dirName);
    ~MainWindow();
    static MainWindow *self;
    QString projectVersion;
    QString strippedName(const QString &fullFileName);
    const QString AbsDir(const QString fileName) const;
    QString& GetDataDirName(){return dataDirName;}
protected:
    void closeEvent(QCloseEvent *event);
private slots:
    void about();
    void zoomin();
    void zoomout();
    void print();
    void pdf();
    void ps();
    void exportData();
private:
    void createActions();
    void createMenus();
    void createToolBars();
    void createStatusBar();
    void readSettings();
    void writeSettings();
    void loadProjectDirectory(const QString &dirName);
    void configure();
    void SetGraphWidget ();
    void SetFontToGraph();
    void PrintPrinterPainter(QPrinter &printer,QwtPlotPrintFilter &filter) ;
    QMenu *fileMenu;
    QMenu *helpMenu;
    QToolBar *fileToolBar;
    QAction *exitAct;
    QAction *zoominAct;
    QAction *zoomoutAct;
    QAction *printAct;
    QAction *psAct;
    QAction *pdfAct;
    QAction *exportAct;
    QAction *aboutAct;
    QAction *aboutQtAct;
    QString dataDirName;
    CDataInfo* dataInfo;



   int indNormalization; //0- commnon maximum 1 - love own & Rayleigh own  2 - own maximum 
   int currentPage;

   GraphWin* graphWin;

   vector<CDataSet* > dvector;
   vector< vector<CDataSet* >::iterator > viter;

   int numberPageLove;
   int numberPageLoveRem;
   int numberPageRayleigh;
   int numberPageRayleighRem;
   int numberPage;
   int numRow;
   int numCol;
   int numCurve;
};
#endif
