#!/bin/csh -f

if($#argv == 0) then
    echo ========================================
    echo plot the best solutions
    echo " "
    echo 'mech.com <mech file> <postscript file>'
    echo " "
    echo GMT VERSION is 3.4
    echo ========================================
    exit
endif

# decoding command line
set mech_file = $argv[1]
set ps_file = $argv[2]

@ nl = `cat $mech_file | wc -l`
@ ntitle = `awk 'BEGIN{t=0}{if(substr($0,1,1)=="t") t=t+1;}END{print t}' $mech_file`
@ nd = $nl - $ntitle
@ npage = $nd / 8
@ nleft = $nd % 8

set yoffset0 = 0.
set xoffset0 = 0.
set hw = 4.1
set h = 10.5

gmtdefaults -D > .gmtdefaults
gmtset HEADER_FONT_SIZE 24p  MEASURE_UNIT inch
set inch = i
set projx = (-Jx1$inch -P)

# print title
@ it = 0
while ($it < $ntitle)
    @ it++
    set title = `head -$it $mech_file | tail -1|cut -c2-120`
    if($it == 1) then
        pstext -R0/1/0/1 $projx -N -X$xoffset0$inch \
            -Y$yoffset0$inch -K << enddata > $ps_file
`echo $hw`  `echo $h-0.4\*$it|bc` 14 0 1 2 `echo "$title"`
enddata
    else
        set offset_over = (-X0$inch -Y$0$inch -K -O)
        pstext -R0/1/0/1 $projx -N -O -K << enddata >> $ps_file
`echo $hw`  `echo $h-0.4\*$it|bc` 14 0 1 2 `echo "$title"`
enddata
    endif
end

# LOOP OVER MECH FILES
if ($npage == 0) then
    psmeca $mech_file -H$ntitle -a0.04${inch}/cc -R0/20/0/20 $projx -G0/0/255 \
        -E240/255/255 -L -Sa2$inch/9/0.2 -N -O -X0$inch -Y0$inch \
        -t1/240/255/255 -p1/0/0/255 -W1/0/0/255 >> $ps_file
else 
    @ ip = 0
    while ($ip < $npage)
        @ ip++
        @ id = $ip * 8 + $ntitle
        if($ip == 1) then
            set over = -O
        else
            set over = ""
        endif
        head -$id $mech_file | tail -8 | \
            psmeca -a0.04${inch}/cc -R0/20/0/20 $projx -G0/0/255 \
            -E240/255/255 -L -W1/0/0/255  -Sa2$inch/9/0.2 -N -t1/240/255/255 \
            -p1/0/0/255 -X0$inch -Y0$inch $over >> $ps_file
    end

    if($nleft) then
        tail -$nleft $mech_file | \
            psmeca -a0.04${inch}/cc -R0/20/0/20 $projx -G0/0/255 \
            -E240/255/255 -L -W1/0/0/255  -Sa2$inch/9/0.2 -N -t1/240/255/255 \
            -p1/0/0/255 -X$xoffset0$inch -Y$yoffset0$inch >> $ps_file
    endif
endif

if ( $FMT_ARCHITECTURE_ =~ linux ) then
ghostview $ps_file 
endif
if ( $FMT_ARCHITECTURE_ =~ solaris ) then
gv -media a4 $ps_file  
endif
